package net.minecraft.src.buildcraft.krapht;

import java.util.HashMap;

import net.minecraft.src.Block;
import net.minecraft.src.ItemRenderer;
import net.minecraft.src.ItemStack;
import net.minecraft.src.ModLoader;
import net.minecraft.src.RenderItem;
import net.minecraft.src.mod_LogisticsPipes;
import net.minecraft.src.krapht.gui.KraphtBaseGuiScreen;
import net.minecraft.src.krapht.ItemIdentifier;

public class GUIOrderer extends KraphtBaseGuiScreen{

	private final IRequestItems _itemRequester;
	private HashMap<ItemIdentifier, Integer> _availableItems;
	
	private RenderItem renderItem = new RenderItem();
	
	private int x;
	private int y;
			
	
	
	public GUIOrderer(IRequestItems itemRequester) {
		super(200,200,0,0);
		_itemRequester = itemRequester;
		_availableItems = mod_LogisticsPipes.logisticsManager.getAvailableItems(_itemRequester.getRouter().getRouteTable().keySet());
		
	}
	
	@Override
	public boolean doesGuiPauseGame() {
		return false;
	}
	
	@Override
	public void drawScreen(int i, int j, float f) {
		// TODO Auto-generated method stub
		drawGuiBackGround();
		fontRenderer.drawString(i+"", 10, 10, 0x404040);
		int ppi = 0;
		for(ItemIdentifier item : _availableItems.keySet()) {
			ppi++;
			ItemStack st = item.makeNormalStack(_availableItems.get(item)+20000);
			//renderItem.renderItemIntoGUI(fontRenderer, mc.renderEngine, st, 160 + 40 * ppi / 20 , 20 + (ppi % 20L) * 20);
			renderItem.renderItemOverlayIntoGUI(fontRenderer, mc.renderEngine, st, 160 + 40 * ppi / 20 , 20 + (ppi % 20) * 20);	
		}
		
	}
	
	
	
	
}
